// dealership3.java

interface inventory
{
   int getQuantity ();
   double getUnitCost ();
}

abstract class vehicle
{
   private String color;
   private String make;
   private String model;
   private int numTires;

   public vehicle (String color, String make, String model, int numTires)
   {
      this.color = color;
      this.make = make;
      this.model = model;
      this.numTires = numTires;
   }

   public String toString ()
   {
      return "Color = " + color + "\nMake = " + make + "\nModel = " + model +
             "\nNumber of tires = " + numTires;
   }

   public abstract void makeNoise ();
}

class truck extends vehicle implements inventory
{
   private int numDoors;
   
   public truck (String color, String make, String model, int numDoors)
   {
      super (color, make, model, 4);

      this.numDoors = numDoors;
   }

   public String toString ()
   {
      return super.toString () + "\nNumber of doors = " + numDoors;
   }

   public void makeNoise () { System.out.println ("Honk! Honk!"); }

   public int getQuantity () { return 6; }
   public double getUnitCost () { return 12600.0; }
}

class motorcycle extends vehicle implements inventory
{
   public motorcycle (String color, String make, String model)
   {
      super (color, make, model, 2);
   }

   public void makeNoise () { System.out.println ("Vroom! Vroom!"); }

   public int getQuantity () { return 8; }
   public double getUnitCost () { return 3750.0; }
}

class part implements inventory
{
   private String name;
   private int quantity;
   private double unitCost;

   public part (String name, int quantity, double unitCost)
   {
      this.name = name;
      this.quantity = quantity;
      this.unitCost = unitCost;
   }

   public String toString () { return name; }

   public int getQuantity () { return quantity; }
   public double getUnitCost () { return unitCost; }
}

class dealership3
{
   public static void main (String [] args)
   {
      System.out.println ("Dealership3...\n");

      vehicle [] v =
      {
         new truck ("Red", "Ford", "F150", 2),
         new motorcycle ("Black", "Honda", "Shadow")
      };

      for (int i = 0; i < v.length; i++)
      {
           System.out.println (v [i]);
           v [i].makeNoise ();
           System.out.println ("");
      }

      System.out.println ("");

      inventory [] inv = new inventory [v.length + 1];
      for (int i = 0; i < v.length; i++)
           inv [i] = (inventory) v [i];
      inv [inv.length - 1] = new part ("Lug nut", 27, 1.23);

      for (int i = 0; i < inv.length; i++)
      {
           if (inv [i] instanceof part)
           {
               System.out.println ("Parts Inventory");
               System.out.println ("---------------");
           }
           else
           {
               System.out.println ("Vehicle Inventory");
               System.out.println ("-----------------");
           }

           System.out.println ("\n" + inv [i]);
           System.out.println ("Quantity = " + inv [i].getQuantity ());
           System.out.println ("Unit cost = " + inv [i].getUnitCost ());
           System.out.println ("Total cost = " + (inv [i].getQuantity () *
                               inv [i].getUnitCost ()) + "\n");
      }
   }
}
