// lsearch.java

class node
{
   private int data;
   private node next;

   node (int data)
   {
      setData (data);
      setNext (null);
   }

   void setData (int data)
   {
      this.data = data;
   }

   int getData ()
   {
      return data;
   }

   void setNext (node next)
   {
      this.next = next;
   }

   node getNext ()
   {
      return next;
   }
}

class lsearch
{
   public static void main (String [] args)
   {
      int [] numbers =
      {
          45, -3, 98, 79, 42, 21, 1000, -333, 42, 42, 0, 100000
      };

      // Create a root node containing the first number.

      node top = new node (numbers [0]);

      // For each remaining number...

      for (int i = 1; i < numbers.length; i++)
      {
           // Create a node for each number.

           node data = new node (numbers [i]);

           // Insert node at the front of the linked list.

           data.setNext (top);
           top = data;
      }

      // Display all nodes.

      node temp = top;
      while (temp != null)
      {
         System.out.println (temp.getData ());
         temp = temp.getNext ();
      }

      // Display a blank line.

      System.out.println ("");

      // Search for 79.

      temp = top;
      while (temp != null)
         if (temp.getData () == 79)
         {
             System.out.println ("79 found");
             break;
         }
         else
             temp = temp.getNext ();

      if (temp == null)
          System.out.println ("79 not found");

      // Search for -79.

      temp = top;
      while (temp != null)
         if (temp.getData () == -79)
         {
             System.out.println ("-79 found");
             break;
         }
         else
             temp = temp.getNext ();

      if (temp == null)
          System.out.println ("-79 not found");
   }
}
