// JFCDemo2.java

import javax.swing.*;

import java.awt.*;
import java.awt.event.*;

class JFCDemo2
{
   static String [] msgs =
   {
      "Welcome to JFC",
      "JFC includes the Abstract Windowing Tookit",
      "JFC includes Swing",
      "JFC includes Java2D",
      "JFC includes Accessibility",
      "JFC includes Drag and Drop"
   };

   final static JLabel l = new JLabel (msgs [0]);

   public static void main (String [] args)
   {
      if (args.length != 1)
          selectLookAndFeel ("Metal");
      else
          selectLookAndFeel (args [0]);

      JFrame f = new JFrame ("JFCDemo #2");
      f.addWindowListener
      (new WindowAdapter ()
           {
              public void windowClosing (WindowEvent e)
                          {
                             System.exit (0);
                          }
           }
      );

      JPanel pane = new JPanel ();
      pane.setLayout (new BorderLayout ());

      JButton b = new JButton ("Press Me!");
      b.addActionListener
      (new ActionListener ()
           {
              public void actionPerformed (ActionEvent ae)
                          {
                             int n = (int) (Math.random () *
                                            msgs.length);
                              l.setText (msgs [n]);
                          }
           }
      );
      pane.add ("North", b);

      pane.add ("South", l);

      f.setContentPane (pane);

      f.setSize (300, 100);
      f.setVisible (true);
   }

   private static void selectLookAndFeel (String lnfName) 
   {
      String actualName = null;

      if (lnfName.equals ("Metal"))
          actualName =
             UIManager.getCrossPlatformLookAndFeelClassName ();
      else
      if (lnfName.equals ("System"))
          actualName =
             UIManager.getSystemLookAndFeelClassName ();
      else
      if (lnfName.equals ("Mac"))
          actualName =
             "com.sun.java.swing.plaf.mac.MacLookAndFeel";
      else
      if (lnfName.equals ("Windows"))
          actualName =
             "com.sun.java.swing.plaf.windows.WindowsLookAndFeel";
      else
      if (lnfName.equals ("Motif"))
          actualName =
             "com.sun.java.swing.plaf.motif.MotifLookAndFeel";

      try
      {
          UIManager.setLookAndFeel (actualName);
      }
      catch (ClassNotFoundException e)
      {

          System.err.println ("Unable to find class that " +
                              "specifies " + actualName +
                              " look and feel.");
      }
      catch (UnsupportedLookAndFeelException e)
      {
          System.err.println (actualName +
                              " look and feel not supported.");
      }
      catch (Exception e)
      {
          System.err.println ("Could not get " + actualName +
                              " look and feel for some reason.");
      }
   }
}
