// pcDemo1.java

class pcDemo1
{
   public static void main (String [] args)
   {
      shared s = new shared ();

      producer p = new producer (s);
      consumer c = new consumer (s);

      p.start ();
      c.start ();
   }
}

class shared
{
   private int s = -1;
   private boolean anyMoreData = true;

   public void setShared (int s) { this.s = s; }
   public int getShared () { return s; }
   public boolean anyMoreData () { return anyMoreData; }
   public void setAnyMoreData (boolean b) { anyMoreData = b; }
}

class producer extends Thread
{
   private shared s;

   producer (shared s)
   {
      this.s = s;
   }

   public void run ()
   {
      for (int i = 0; i < 15; i++)
      {
           try
           {
               // Sleep from 0 to 3999 milliseconds.

               Thread.sleep ((int) (Math.random () * 4000));
           }
           catch (InterruptedException e)
           {
               System.err.println (e);
           }

           s.setShared (i);
           System.out.println (i + " produced by producer.");
      }

      s.setAnyMoreData (false);
   }
}

class consumer extends Thread
{
   private shared s;

   consumer (shared s)
   {
      this.s = s;
   }

   public void run ()
   {
      while (s.anyMoreData ())
      {
         try
         {
             // Sleep from 0 to 3999 milliseconds.

             Thread.sleep ((int) (Math.random () * 4000));
         }
         catch (InterruptedException e)
         {
             System.err.println (e);
         }

         System.out.println (s.getShared () + " consumed by consumer.");
      }
   }
}


