// philos.java

class philos
{
   public static void main (String [] args)
   {
      fork f1 = new fork ();
      fork f2 = new fork ();
      fork f3 = new fork ();
      fork f4 = new fork ();
      fork f5 = new fork ();

      philosopher fred = new philosopher ("fred", f1, f5);
      philosopher john = new philosopher ("john", f2, f1);
      philosopher alice = new philosopher ("alice", f3, f2);
      philosopher wanda = new philosopher ("wanda", f4, f3);
      philosopher pete = new philosopher ("pete", f5, f4);

      fred.start ();
      john.start ();
      alice.start ();
      wanda.start ();
      pete.start ();
   }
}

class philosopher extends Thread 
{
   private String name;
   private fork left;
   private fork right;

   philosopher (String name, fork left, fork right)
   {
       this.name = name;
       this.left = left;
       this.right = right;
   }

   public void run ()
   {
       while (true)
       {
          try
          {
              System.out.println ("Philosopher " + name +
                                  " is thinking.");
               
              sleep((int) (100 * Math.random ()));

              System.out.println ("Philosopher " + name +
                                  " is hungry.");
 
              if (left.get (name) < 0)
              {
                  System.out.println ("Philosopher " + name +
                                      " is dead.");
                  break;
              }

              System.out.println ("Philosopher " + name +
                                  " got the left fork.");

              if (right.get (name) < 0)
              {
                  System.out.println ("Philosopher " + name +
                                      " is dead.");
                  break;
              }

              System.out.println ("Philosopher " + name +
                                  " got the right fork.");

              sleep (500);

              System.out.println ("Philosopher " + name +
                                  " is eating.");

              sleep ((int) (50 * Math.random ()));

              left.put ();
              System.out.println ("Philosopher " + name +
                                  " putting down left fork.");

              right.put ();
              System.out.println ("Philosopher " + name +
                                  " putting down right fork.");
          } 
          catch (java.lang.InterruptedException e) {}
       }
   }
}

class fork
{
   private boolean taken = false;

   void put ()
   {
      taken = false;
   }
/*
   synchronized void put ()
   {
      taken = false;
      notify ();
   }
*/
   int get (String name)
   {
      long counter = 0;

      while (taken)
         if (counter > 450)
             return -1;
         else
         if (++counter > 400)
             System.out.println ("Philosopher " + name +
                                 " is starving!");

      taken = true;

      return 0;
   }
/*
   synchronized int get (String name)
       throws java.lang.InterruptedException
   {
      long counter = 0;

      while (taken)
         if (counter > 450)
             return -1;
         else
         if (++counter > 400)
         {
             System.out.println ("Philosopher " + name +
                                 " is starving!");

             wait ();
         }

      taken = true;

      return 0;
   }*/
}
